// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js

angular.module('zodiac', ['ionic','slideMenu','ngCordova','ion-google-place','angularMoment','ngEmoticons','angular.filter','ngMessages','rzModule'])

.run(function($ionicPlatform) {

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
  });
})
    .config(function ($stateProvider, $urlRouterProvider,$ionicConfigProvider) {
        // $ionicConfigProvider.views.maxCache(5);
        $stateProvider

            .state('app', {
                url: '/app',
                abstract: true,
                templateUrl: 'app/templates/menu/menu.html',
                controller: 'MenuController'
            })

            .state('login', {
                url: '/login',
                templateUrl: 'app/templates/login/login.html',
                controller  : 'LoginController'
            })

            .state('forgot', {
                url: '/forgot',
                templateUrl: 'app/templates/forgot/forgot.html',
                controller : 'ForgotController'
            })

            .state('signup', {
                url: '/signup',
                templateUrl: 'app/templates/signup/signup.html',
                controller  : 'SignupController'
            })

            .state('intro', {
                url: '/intro',
                templateUrl: 'app/templates/intro/intro.html',
                controller : 'IntroController'
            })

            /*.state('dashboard', {
                url: '/dashboard',
                templateUrl: 'app/templates/dashboard/dashboard.html',
                controller  : 'DashboardController'
            })*/
            .state('app.dashboard', {
                url: '/dashboard',
                views:{
                    'menuContent':{
                        templateUrl: 'app/templates/dashboard/dashboard.html',
                        controller: 'DashboardController'
                    }
                }
            })

            .state('welcome', {
                
                url: '/welcome',
                templateUrl: 'app/templates/welcome/welcome.html'
            })
            
            .state('app.profile', {
                url: '/profile',
                views:{
                    'menuContent':{
                        templateUrl: 'app/templates/profile/profile.html',
                        controller:'ProfileController'
                    }
                }
            })
            .state('app.edit-profile', {
                url: '/edit-profile',
                views:{
                    'menuContent':{
                        templateUrl: 'app/templates/edit-profile/edit-profile.html',
                        controller:'EditProfileController',
                    }
                }
            })

            .state('app.change-password', {
                url: '/change-password',
                views:{
                    'menuContent':{
                        templateUrl: 'app/templates/change/change.html',
                        controller:'ChangeController',
                    }
                }
            })
            .state('app.privacy-policy', {
                url: '/privacy-policy',
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/privacy-policy/privacy-policy.html'
                        // controller : 'AccordionCtrl'
                    }
                }
            })
            .state('app.about-app', {
                url: '/about-app',
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/about/about.html'
                    }
                }
            })
            .state('app.search-result', {
                url: '/search-result',
                params: {
                    westernSignsId: null,
                    western:null,
                    chineseSignsId: null,
                    chinese : null,
                    more : null
                },
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/search-result/search-result.html',
                        controller:'SearchResultCtrl'

                    }
                }
            })
            .state('app.profile-view', {
                url: '/profile-view',
                views:{
                    'menuContent':{
                        templateUrl: 'app/templates/profile-view/profile-view.html',
                    }
                }

            })
            .state('app.chatting', {
                url: '/chatting/:chatId',
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/chatting/chatting.html',
                        controller: 'ChatController'
                    }
                }
            })

            .state('app.chatting-all', {
                url: '/chatting-all',
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/chatting-all/chatting-all.html',
                        controller: 'ChatsController'
                    }
                }
            })
            .state('app.terms-and-conditions', {
                url: '/privacy-policy',
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/terms-and-conditions/terms-and-conditions.html'
                        // controller : 'AccordionCtrl'
                    }
                }
            })
            .state('app.search-nearby', {
                url: '/search-nearby',
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/search-nearby/search-nearby.html',
                        controller : 'SearchNearByController'
                    }
                }
            })
            .state('app.scanUserProfile', {
                url: '/scanUserProfile/:userId',
                views: {
                    'menuContent':{
                        templateUrl: 'app/templates/search-nearby/scan-userProfile.html',
                        controller: 'UsersProfileController'
                    }
                }
            })
            .state('app.nearby-list', {
            url: '/nearby-list',
                params: {
                    more: null
                },
            views: {
                'menuContent':{
                    templateUrl: 'app/templates/search-nearby/nearbyList.html',
                    controller : 'nearbyListController'
                }
            }
        });

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/intro');

        console.log('auth ',window.localStorage.getItem('auth'));

        if(window.localStorage.getItem('auth')==null){
            if(window.localStorage.getItem('intro')!=null){

                $urlRouterProvider.otherwise('/login');
                // console.log('inside intro  true');
            }else{
                $urlRouterProvider.otherwise('/intro');
                // console.log('inside intro not true');
            }
        }else{
            console.log('inside auth');
            console.log('auth 197',window.localStorage.getItem('auth')=='true');


            $urlRouterProvider.otherwise('/app/dashboard');


        }


        /*if(window.localStorage.getItem('auth') == null){
            $urlRouterProvider.otherwise('/dashboard');
        }else{
            $urlRouterProvider.otherwise('/intro');
        }*/
        /*if(window.localStorage.getItem('intro') == null){
            $urlRouterProvider.otherwise('/intro');
        }else{
            if(window.localStorage.getItem('auth') == null){
                $urlRouterProvider.otherwise('/login');
            }
        }*/
    }).run(function($ionicPlatform,$cordovaPushV5,$rootScope,appRequestApi) {

        $ionicPlatform.ready(function() {

            /*var androidConfig = {
                "senderID": "481202023917",
                "forceShow" : true,
                "vibrate" : true
            };*/

            var options = {
                android: {
                    senderID: "481202023917"
                },
                ios: {
                    alert: "true",
                    badge: "true",
                    sound: "true"
                },
                windows: {}
            };

            // initialize
            $cordovaPushV5.initialize(options).then(function() {
                // start listening for new notifications
                $cordovaPushV5.onNotification();
                // start listening for errors
                $cordovaPushV5.onError();

                // register to get registrationId
                $cordovaPushV5.register().then(function(registrationId) {
                    // save `registrationId` somewhere;
                    var register_id = {
                        'device_id':registrationId
                    };
                    window.register_object = register_id;
                    console.log('device_id',register_id.device_id);
                })
            });

            // triggered every time notification received
            $rootScope.$on('$cordovaPushV5:notificationReceived', function(event, data){
                // data.message,
                // data.title,
                // data.count,
                // data.sound,
                // data.image,
                // data.additionalData
                console.log('data received',data);
            });



            /*document.addEventListener("deviceready", function () {
                $cordovaPush.register(androidConfig).then(function (result) {
                    // Success
                    console.log('result:', result);
                }, function (err) {
                    // Error
                });

                $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
                    switch (notification.event) {
                        case 'registered':
                            if (notification.regid.length > 0) {

                                console.log('registration ID = ' + notification.regid);
                                var register_id = {
                                    'device_id':notification.regid
                                };
                                window.register_object = register_id;
                                 console.log('device_id',register_id.device_id);
                            }
                            break;

                        case 'message':
                            // this is the actual push notification. its format depends on the data model from the push server
                            console.log('notification ',notification);
                            console.log('message = ' + notification.message + ' msgCount = ' + notification.msgcnt);
                            break;

                        case 'error':
                            alert('GCM error = ' + notification.msg);
                            break;

                        default:
                            alert('An unknown GCM event has occurred');
                            break;
                    }
                });


                /!*!// WARNING: dangerous to unregister (results in loss of tokenID)
                 $cordovaPush.unregister(options).then(function(result) {
                 // Success!
                 }, function(err) {
                 // Error
                 })*!/

            }, false);*/
        });
    });