/**
 * Created by osp57 on 21/12/16.
 */
'use strict';
var app = angular.module('zodiac');

app.controller('ChatController', ['$scope','appRequestApi','URL_API','$state','BASE_URL_API','$ionicLoading','socket','$stateParams','$ionicScrollDelegate','$ionicHistory','moment','$http','$location','$filter', function ($scope,appRequestApi,URL_API,$state,BASE_URL_API,$ionicLoading,socket,$stateParams,$ionicScrollDelegate,$ionicHistory,moment,$http,$location,$filter) {

    var profile_url= BASE_URL_API+'user';
    var other_profile_url= BASE_URL_API+'user/other/profile';
    var chats_url= BASE_URL_API+'user/chat/messages';

    $scope.to_user = {};
    $scope.send = {message:''};
    var to_user_id = $stateParams.chatId;
    console.log(' param ',to_user_id);


    $ionicLoading.show({
        template: 'Please wait...'
    });


    appRequestApi.requestGet(profile_url).then(function(data){

        if(data.status==true){
            $scope.user = data.data;
        }

    });
    appRequestApi.requestPost(other_profile_url,{user_id:to_user_id}).then(function(data){

        //$ionicLoading.hide();

        if(data.status==true){
            $scope.to_user = data.data;
        }

    });

    appRequestApi.requestPost(chats_url,{user_id:to_user_id}).then(function(data){
        
        $ionicLoading.hide();
        console.log('chat_messages',data);
        if(data.status==true){

            $scope.chatMessages = data.chats;
            if($scope.chatMessages.length>3){

                $ionicScrollDelegate.scrollBottom();
            }

        }else{

        }

    });

    $scope.loadMoreChat = function(){
      console.log(1);
        appRequestApi.requestPost(chats_url,{user_id:to_user_id}).then(function(data){

            $ionicLoading.hide();
            console.log('chat_messages',data);
            if(data.status==true){
                $scope.chatMessages = data.chats;

            }else{

            }

        });
    };



    $scope.user_id = window.localStorage['user_id'];
    
    var user_id =  window.localStorage['user_id'];
    console.log('user id',user_id);

    var join_obj = {user_id:user_id,to_user_id:to_user_id};
    console.log('join obj:',join_obj);


    socket.emit('user:join',join_obj);
    // socket.emit('user:join',{user_id:user_id,to_user_id:to_user_id});

    socket.emit('user:info',{to_user_id:to_user_id});

    //$ionicLoading.hide();

    $scope.$parent.socket_check();

    $scope.sendMessage = function () {
        console.log({from:user_id,to:to_user_id,message:$scope.send.message});
        socket.emit('chat:received',{from:user_id,to:to_user_id,message:$scope.send.message});
        var d = new Date();
        var dt = $filter('date')(d, " h:mma");
        console.log('dt', dt);
        $("<div class='chat-main'><div class='chat-left chat-right'><div class='logos user-match text_left'><Div class='logo-inner'><img src='"+$scope.user.image+"'></div></div><div class='chat_text'><p>"+$scope.send.message+"</p><span>"+dt+"</span></div></div></div>").appendTo(".chatting_wrap");
        $scope.send = {message:''};
        $ionicScrollDelegate.scrollBottom();

    };

    socket.on('user:get_message',function(data){
        console.log('data',data);
        var dt = $filter('date')(data.timestamp, " h:mma");
        $("<div class='chat-main'><div class='chat-left'><div class='logos user-match text_left'><Div class='logo-inner'><img src='"+$scope.to_user.image+"'></div></div><div class='chat_text'><p>" + data.message + "</p><span>"+dt+"</span></div></div></div>").appendTo(".chatting_wrap");
        
        if(data.to == to_user_id){
            console.log('data to user',data);
        }

       /* if(data.to==to_user_id) {

            $("<div class='chat-main'><div class='chat-left'><div class='logos user-match text_left'><Div class='logo-inner'><img src='"+$scope.to_user.image+"'></div></div><div class='chat_text'><p>" + data.message + "</p><span>9:30 AM</span></div></div></div>").appendTo(".chatting_wrap");
        }else{
            $("<div class='chat-main'><div class='chat-left chat-right'><div class='logos user-match text_left'><Div class='logo-inner'><img src='"+$scope.user.image+"'></div></div><div class='chat_text'><p>"+$scope.send.message+"</p><span>9:30 AM</span></div></div></div>").appendTo(".chatting_wrap");
        }*/
        $ionicScrollDelegate.scrollBottom();

    });

    $scope.goBackFromChat = function () {
        $ionicHistory.goBack(-1);
    };

   
    $scope.clickSmiley = function(){
      console.log('inside smiley',1);
    };
    
    $scope.test = function(t){
        console.log(t);
    };

    window.addEventListener('native.keyboardshow', keyboardShowHandler, false);
    window.addEventListener('native.keyboardhide', keyboardShowHandler, false);
    function keyboardShowHandler(e) {
        console.log('location path',$location.path());
        if ($location.path().indexOf('chatting/'+to_user_id) > -1) {
            $ionicScrollDelegate.scrollBottom();
        }
    }

    /*$scope.emojies = [];
    $scope.tabActive = [];
    $scope.tabActive[0] = true;


    $http.get("lib/emojione/emoji.json").then(function (response) {
        angular.forEach(response.data , function ($elem , $index) {
            $scope.emojies.push($elem);
        });

    });
    $scope.changeTab = function (index) {
        $scope.tabActive = [];
        $scope.tabActive[index] = true;
    };*/
}]);


app.directive('emojiInput', function ($timeout) {
    return {
        restrict: 'A',
        require: 'ngModel',
        link: function ($scope, $el, $attr, ngModel) {
            $.emojiarea.path = 'https://s3-us-west-1.amazonaws.com/dboskovic/jquery-emojiarea-master/packs/basic';
            $.emojiarea.icons = {
                ':smile:': 'smile.png',
                ':angry:': 'angry.png',
                ':flushed:': 'flushed.png',
                ':neckbeard:': 'neckbeard.png',
                ':laughing:': 'laughing.png'
            };
            var options = $scope.$eval($attr.emojiInput);
            var $wysiwyg = $($el[0]).emojiarea(options);
            $wysiwyg.on('change', function () {
                ngModel.$setViewValue($wysiwyg.val());
                $scope.$apply();
            });
            ngModel.$formatters.push(function (data) {
                // emojiarea doesn't have a proper destroy :( so we have to remove and rebuild
                $wysiwyg.siblings('.emoji-wysiwyg-editor, .emoji-button').remove();
                $timeout(function () {
                    $wysiwyg.emojiarea(options);
                }, 0);
                return data;
            });
        }
    };
});

