
/**
 * Created by osp57 on 28/11/16.
 */

'use strict';
var app = angular.module('zodiac');

app.controller('SearchResultCtrl', ['$scope','$state','$q','$ionicLoading','$ionicPopup','appRequestApi','BASE_URL_API','$stateParams','$ionicScrollDelegate','$timeout','$location', function ($scope,$state,$q,$ionicLoading,$ionicPopup,appRequestApi,BASE_URL_API,$stateParams,$ionicScrollDelegate,$timeout,$location) {

    $scope.slider = {
        min: 18,
        max: 50,
        options: {
            floor: 18,
            ceil: 100
        }

    };


    $scope.$parent.socket_check();


    $scope.profile={
        isWesternGrid:'',
        isChineseGrid:''
    };
    $scope.profile.isWesternGrid = false;

    $scope.profile.isChineseGrid = false;

    if($stateParams.western==null && $stateParams.chinese==null){
        $scope.zodiac ={
            sign:false
        } ;
        $scope.set_western_sign_id = 1;
        $scope.set_chinese_sign_id = 13;

    }else{
        console.log($stateParams);
        if($stateParams.western==true && $stateParams.chinese==null){

            $scope.zodiac ={
                sign:false
            } ;

            if($stateParams.westernSignsId!=null){
                $scope.set_western_sign_id = $stateParams.westernSignsId;
                 //$ionicScrollDelegate.$getByHandle('western-scroll').scrollTo(25,0,true);

                $scope.set_chinese_sign_id = 13;
            }else{
                $scope.set_western_sign_id = 1;
            }

        }

        if($stateParams.western==null && $stateParams.chinese==true){

            $scope.set_western_sign_id = 1;

            $scope.zodiac ={
                sign:true
            } ;
            if($stateParams.chineseSignsId!=null){

                $scope.set_chinese_sign_id = $stateParams.chineseSignsId;

            }else{

                $scope.set_chinese_sign_id = 13;

            }
        }
    }
    $scope.moreLoadData = true;
    $scope.count = {
        page:2
    };

    $scope.change={
        sign:false
    };
    $scope.infinite={};

    $scope.changeSigns = function(sign){

        $scope.change={
            sign:sign
        };

    };

    $scope.is_filter = false;

    var search_infinite_result;

    $scope.loadmore = function () {

        if($scope.change.sign==true){
            $scope.infinite={
                _id : $scope.set_chinese_sign_id
            };
        }else{
            $scope.infinite={
                _id : $scope.set_western_sign_id
            };
        }
        console.log($scope.slider);

        if($scope.is_filter==false) {
             search_infinite_result = BASE_URL_API + 'user/best/matches?page=' + $scope.count.page + '&signs_id=' + $scope.infinite._id;
        }else{
             search_infinite_result = BASE_URL_API + 'user/best/matches?page='+ $scope.count.page +'&gender='+$scope.filter.gender+'&range='+$scope.filter.range+'&signs='+$scope.filter.signs+ '&signs_id=' + $scope.infinite._id +'&min_age='+ $scope.slider.min + '&max_age='+ $scope.slider.max;
        }
        console.log(search_infinite_result);
        appRequestApi.requestGet(search_infinite_result).then(function(data){

            $ionicLoading.hide();
            $scope.best_match = data.best_match;

            angular.forEach($scope.best_match,function (value,key) {
                if(value.western_zodiac){

                    $scope.western = value.western_zodiac;
                }
                if(value.chinese_zodiac){
                    $scope.chinese = value.chinese_zodiac;
                }
            });

        });
        $scope.count.page++;

    };
    var search_result;
    
    if($stateParams.western==null && $stateParams.chinese==null) {
        search_result = BASE_URL_API + 'user/best/matches?page=1&matches=best_3';

    }else{
        search_result = BASE_URL_API + 'user/best/matches?page=1';
    }

    $ionicLoading.show({
        template: '<ion-spinner ></ion-spinner>'
    });
    //api to get all users with matching signs
    appRequestApi.requestGet(search_result).then(function(data){

        $ionicLoading.hide();
        // console.log(data);
        $scope.best_match = data.best_match;

        angular.forEach($scope.best_match,function (value,key) {
            if(value.western_zodiac){

                $scope.western = value.western_zodiac;
            }
            if(value.chinese_zodiac){

                $scope.chinese = value.chinese_zodiac;

            }
        });

        $timeout(function() {
            var pos_western = $('.western-slide').find('#western_slide_'+$scope.set_western_sign_id).position();
            var pos_chinese = $('.chinese-slide').find('#chinese_slide_'+$scope.set_chinese_sign_id).position();

            $ionicScrollDelegate.$getByHandle('western-scroll').scrollTo(pos_western.left,0,true);
            $ionicScrollDelegate.$getByHandle('chinese-scroll').scrollTo(pos_chinese.left,0,true);
        }, 400);

    });

    $scope.viewProfile = function(){

      $state.go('app.other-profile');

    };

    $scope.showPopup = function(){
        var myPopup = $ionicPopup.show({
            template: '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse fermentum sem ante, in auctor purus semper eget. Vestibulum volutpat magna sit a</p>',
            title: 'NOTIFICATION',
            scope: $scope,
            buttons: [
            { text: '<img src="img/pop-up-cross.png">' },
            {
                text: 'Done',
                type: 'button-positive',
                onTap: function(e) {
                    return true;
                }
            },
            ]
        });
    };

    $scope.changeWesternSigns = function (sign_id) {
        $scope.set_western_sign_id = sign_id;
    };

    $scope.changeChineseSigns = function (sign_id) {

        $scope.set_chinese_sign_id = sign_id;
    };
    $scope.showWesternUserProfile = function (id) {
        console.log(id);

        $scope.profile.isWesternGrid = true;
        $ionicScrollDelegate.scrollTop();
        $timeout(function() {
            var pos_western = $('.western-slide').find('#western_slide_'+$scope.set_western_sign_id).position();
            // var pos_chinese = $('.chinese-slide').find('#chinese_slide_'+$scope.set_chinese_sign_id).position();
            // console.log(pos_western.left);
            $ionicScrollDelegate.$getByHandle('western-scroll').scrollTo(pos_western.left,0,true);
            
            var pos_western_portrait = $('.western-portrait-area').find('#western_protrait_profile_'+id).position();
            console.log(pos_western_portrait);
            $ionicScrollDelegate.$getByHandle('western_protrait_scroll').scrollTo(pos_western_portrait.left,0,true);
            // $ionicScrollDelegate.$getByHandle('chinese-scroll').scrollTo(pos_chinese.left,0,true);
        }, 400);

    };
    $scope.showWesternGridView = function () {
        $scope.profile.isWesternGrid = false;
    };
    $scope.showChineseUserProfile = function (id) {
        console.log(id);
        // $ionicScrollDelegate.scrollTop();
        $scope.profile.isChineseGrid = true;
        $ionicScrollDelegate.scrollTop();
        $timeout(function() {
            var pos_chinese = $('.chinese-slide').find('#chinese_slide_'+$scope.set_chinese_sign_id).position();
            // var pos_chinese = $('.chinese-slide').find('#chinese_slide_'+$scope.set_chinese_sign_id).position();
            $ionicScrollDelegate.$getByHandle('chinese-scroll').scrollTo(pos_chinese.left,0,true);

            var pos_chinese_portrait = $('.chinese-portrait-area').find('#chinese_protrait_profile_'+id).position();
            console.log(pos_chinese_portrait);
            $ionicScrollDelegate.$getByHandle('chinese_protrait_scroll').scrollTo(pos_chinese_portrait.left,0,true);
            // $ionicScrollDelegate.$getByHandle('chinese-scroll').scrollTo(pos_chinese.left,0,true);
        }, 400);

    };
    $scope.showChineseGridView = function () {

        $scope.profile.isChineseGrid = false;
    };
    $scope.filter = {};

    $scope.filter = {
       gender :'all',
        signs:'best_3'
    };

    $scope.selectGender = function (value,event) {
        // console.log(value,$(event.target).closest("div").addClass('icon-bg'));
        switch (value){
            case 'all':
                $scope.filter.gender = 'all';
                break;
            case 'male':
                $scope.filter.gender = 'male';
                break;
            case 'female':
                $scope.filter.gender = 'female';
                break;
            default :
                $scope.filter.gender = 'all';
        }
    };
    $scope.page={
        count:0
    };
    $scope.openFilter = function(){

        $scope.is_filter = true;
        $scope.page.count = 1;
        $ionicLoading.show({
            template: '<ion-spinner ></ion-spinner>'
        });

        var search_query_result = BASE_URL_API + 'user/best/matches?page='+ $scope.count.page +'&gender='+$scope.filter.gender+'&range='+$scope.filter.range+'&signs='+$scope.filter.signs+ '&signs_id=' + $scope.infinite._id +'&min_age='+ $scope.slider.min + '&max_age='+ $scope.slider.max;

        $scope.best_match={};
        $scope.western = {};
        $scope.chinese = {};

        appRequestApi.requestGet(search_query_result).then(function(data){
            $ionicLoading.hide();
            //return users
            console.log(data);
            $scope.best_match = data.best_match;

            angular.forEach($scope.best_match,function (value,key) {
                if(value.western_zodiac){

                    $scope.western = value.western_zodiac;
                    $scope.set_western_sign_id= $scope.western[0].signs_id;

                }
                if(value.chinese_zodiac){
                    $scope.chinese = value.chinese_zodiac;
                    $scope.set_chinese_sign_id= $scope.chinese[0].signs_id;

                }
            })
        });
    };



    $timeout(function(){
        //return false; // <--- comment this to "fix" the problem
        var sv = $ionicScrollDelegate.$getByHandle('horizontal').getScrollView();

        var container = sv.__container;

        var originaltouchStart = sv.touchStart;
        var originalmouseDown = sv.mouseDown;
        var originaltouchMove = sv.touchMove;
        var originalmouseMove = sv.mouseMove;

        container.removeEventListener('touchstart', sv.touchStart);
        container.removeEventListener('mousedown', sv.mouseDown);
        document.removeEventListener('touchmove', sv.touchMove);
        document.removeEventListener('mousemove', sv.mousemove);


        sv.touchStart = function(e) {
            e.preventDefault = function(){}
            originaltouchStart.apply(sv, [e]);
        }

        sv.touchMove = function(e) {
            e.preventDefault = function(){}
            originaltouchMove.apply(sv, [e]);
        }

        sv.mouseDown = function(e) {
            e.preventDefault = function(){}
            originalmouseDown.apply(sv, [e]);
        }

        sv.mouseMove = function(e) {
            e.preventDefault = function(){}
            originalmouseMove.apply(sv, [e]);
        }

        container.addEventListener("touchstart", sv.touchStart, false);
        container.addEventListener("mousedown", sv.mouseDown, false);
        document.addEventListener("touchmove", sv.touchMove, false);
        document.addEventListener("mousemove", sv.mouseMove, false);
    });
    $timeout(function(){
        //return false; // <--- comment this to "fix" the problem
        var sv = $ionicScrollDelegate.$getByHandle('horizontal2').getScrollView();

        var container = sv.__container;

        var originaltouchStart = sv.touchStart;
        var originalmouseDown = sv.mouseDown;
        var originaltouchMove = sv.touchMove;
        var originalmouseMove = sv.mouseMove;

        container.removeEventListener('touchstart', sv.touchStart);
        container.removeEventListener('mousedown', sv.mouseDown);
        document.removeEventListener('touchmove', sv.touchMove);
        document.removeEventListener('mousemove', sv.mousemove);


        sv.touchStart = function(e) {
            e.preventDefault = function(){}
            originaltouchStart.apply(sv, [e]);
        }

        sv.touchMove = function(e) {
            e.preventDefault = function(){}
            originaltouchMove.apply(sv, [e]);
        }

        sv.mouseDown = function(e) {
            e.preventDefault = function(){}
            originalmouseDown.apply(sv, [e]);
        }

        sv.mouseMove = function(e) {
            e.preventDefault = function(){}
            originalmouseMove.apply(sv, [e]);
        }

        container.addEventListener("touchstart", sv.touchStart, false);
        container.addEventListener("mousedown", sv.mouseDown, false);
        document.addEventListener("touchmove", sv.touchMove, false);
        document.addEventListener("mousemove", sv.mouseMove, false);
    });

}]).filter('capitalize', function() {
    return function(input, all) {
        var reg = (all) ? /([^\W_]+[^\s-]*) */g : /([^\W_]+[^\s-]*)/;
        return (!!input) ? input.replace(reg, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();}) : '';
    }
}).directive('scrollOnClick', function() {
    return {
        restrict: 'A',
        link: function(scope, $elm, attrs) {
            var idToScroll = attrs.href;
            $elm.on('click', function() {
                var $target;
                if (idToScroll) {
                    $target = $(idToScroll);
                } else {
                    $target = $elm;
                }
                $("body").animate({scrollTop: $target.offset().top}, "slow");
            });
        }
    }
});


// Scroll fix directive
(function() {
    var HorizontalScrollFix = (function() {
        function HorizontalScrollFix($timeout, $ionicScrollDelegate) {
            return {
                restrict: 'A',
                link: function(scope, element, attrs) {
                    var mainScrollID = attrs.horizontalScrollFix,
                        scrollID = attrs.delegateHandle;

                    var getEventTouches = function(e) {
                        return e.touches && (e.touches.length ? e.touches : [
                                {
                                    pageX: e.pageX,
                                    pageY: e.pageY
                                }
                            ]);
                    };

                    var fixHorizontalAndVerticalScroll = function() {
                        var mainScroll, scroll;
                        mainScroll = $ionicScrollDelegate.$getByHandle(mainScrollID).getScrollView();
                        scroll = $ionicScrollDelegate.$getByHandle(scrollID).getScrollView();

                        // patch touchstart
                        scroll.__container.removeEventListener('touchstart', scroll.touchStart);
                        scroll.touchStart = function(e) {
                            var startY;
                            scroll.startCoordinates = ionic.tap.pointerCoord(e);
                            if (ionic.tap.ignoreScrollStart(e)) {
                                return;
                            }
                            scroll.__isDown = true;
                            if (ionic.tap.containsOrIsTextInput(e.target) || e.target.tagName === 'SELECT') {
                                scroll.__hasStarted = false;
                                return;
                            }
                            scroll.__isSelectable = true;
                            scroll.__enableScrollY = true;
                            scroll.__hasStarted = true;
                            scroll.doTouchStart(getEventTouches(e), e.timeStamp);
                            startY = mainScroll.__scrollTop;

                            // below is our changes to this method
                            // e.preventDefault();

                            // lock main scroll if scrolling horizontal
                            $timeout((function() {
                                var animate, yMovement;
                                yMovement = startY - mainScroll.__scrollTop;
                                if (scroll.__isDragging && yMovement < 2.0 && yMovement > -2.0) {
                                    mainScroll.__isTracking = false;
                                    mainScroll.doTouchEnd();
                                    animate = false;
                                    return mainScroll.scrollTo(0, startY, animate);
                                } else {
                                    return scroll.doTouchEnd();
                                }
                            }), 100);
                        };
                        scroll.__container.addEventListener('touchstart', scroll.touchStart);
                    };
                    $timeout(function() { fixHorizontalAndVerticalScroll(); });
                }
            };
        }

        return HorizontalScrollFix;

    })();

    angular.module('zodiac').directive('horizontalScrollFix', ['$timeout', '$ionicScrollDelegate', HorizontalScrollFix]);

}).call(this);