/**
 * Created by osp57 on 28/11/16.
 */

'use strict';

angular.module('zodiac').factory('appRequestApi', ['$http','$state', '$q', '$timeout', '$ionicPopup','$ionicLoading','$cordovaNetwork','$cordovaToast', appRequestApi]);

function appRequestApi($http, $state,$q, $timeout, $ionicPopup,$ionicLoading,$cordovaNetwork,$cordovaToast, CacheFactory) {

    function requestPost(link, data) {
        var header = (window.localStorage.getItem('token') == null) ? '' : window.localStorage['token'];
        var deferred = $q.defer();

        /* var  headers = {
         "Content-Type"   : "application/json",
         "Authorization" : "Bearer "+header
         };*/

        var config = {
            timeout: deferred.promise,
            headers: {
                'Content-Type': 'application/json',
                "Authorization": "Bearer " + header
            }
        };

        $http.post(link, data, config)
            .then(function (data, status, headers, config) {
                // console.log('data.headers().authorization',data.headers().authorization);
                if (data.headers().authorization != null) {

                    var token = data.headers().authorization.replace("Bearer ", "");

                    window.localStorage['token'] = token;
                }

                // console.log('token',token);
                deferred.resolve(data.data);
            }, function (reject) {

                // error handler
               /* if (reject.status === 0) {

                    var alertPopup = $ionicPopup.alert({
                        title: 'Network Problem',
                        template: 'Your internet is too slow',
                        buttons: [
                            {text: '<b>Ok</b>', type: 'button-balanced'}
                        ]
                    });
                }*/
                $ionicLoading.hide();
                // error handler
                if(reject.status == 401 || reject.status == 400){

                    var myPopup = $ionicPopup.show({

                        template: 'Please login.',
                        title: 'Unauthorized access',
                        buttons: [
                            {
                                text: '<b>Ok</b>',
                                type: 'button-positive',
                                onTap: function(e) {
                                    $state.go('login');
                                }
                            }
                        ]
                    });
                }
                var error_msg = 'An error has occurred. Please try again...';
                console.log($cordovaNetwork);
                if(window.cordova) {
                    var isOffline = $cordovaNetwork.isOffline();

                    if (isOffline) {
                        error_msg = 'Your internet is not working. Please check your internet connection.';
                    }
                }
                    $cordovaToast
                        .show(error_msg, 'long', 'center')
                        .then(function(success) {
                            // success
                        }, function (error) {
                            // error
                        });



                deferred.resolve(reject.data);
                deferred.resolve(reject.data);
            });

        $timeout(function () {
            deferred.resolve('status'); // this aborts the request!
        }, 60000);
        return deferred.promise;
    }

    function requestGet(link) {

        var header = (window.localStorage.getItem('token') == null) ? '' : window.localStorage['token'];
        var deferred = $q.defer();

        var headers = {
            "Content-Type": "application/json",
            "Authorization": "Bearer " + header
        };

        $http.get(link, {timeout: deferred.promise, 'headers': headers})
            .then(function (data, status, headers, config) {

                if (data.headers().authorization != null) {

                    var token = data.headers().authorization.replace("Bearer ", "");

                    window.localStorage['token'] = token;
                }
                deferred.resolve(data.data);
            }, function (reject) {
                console.log(reject);
                if (reject.status === 0) {

                    var alertPopup = $ionicPopup.alert({
                        title: 'Network Problem',
                        template: 'Your internet is too slow',
                        buttons: [
                            {text: '<b>Ok</b>', type: 'button-balanced'}
                        ]
                    });
                }

                deferred.resolve(reject.data);
            });

        $timeout(function () {
            deferred.resolve('status'); // this aborts the request!
        }, 60000);

        return deferred.promise;
    }


    return {
        requestPost: requestPost,
        requestGet: requestGet
    };
}

