/**
 * Created by osp57 on 21/12/16.
 */
'use strict';
var app = angular.module('zodiac');

app.controller('SearchNearByController', ['$scope','shareData','appRequestApi','URL_API','$state','BASE_URL_API','$ionicLoading','$ionicModal','$timeout','customGeoReq','$cordovaGeolocation','$cordovaToast', function ($scope,shareData,appRequestApi,URL_API,$state,BASE_URL_API,$ionicLoading,$ionicModal,$timeout,customGeoReq,$cordovaGeolocation,$cordovaToast) {

    var location_url = BASE_URL_API+'user/search/location';
    var profile_url = BASE_URL_API+'user';
    $scope.user_id = window.localStorage.getItem('user_id');
    $scope.slider = {
        min: 18,
        max: 50,
        options: {
            floor: 18,
            ceil: 100
        }

    };

    /*$ionicLoading.show({
        template: '<ion-spinner ></ion-spinner>'
    });*/
    $scope.field={address:''};

    $scope.filter = {};
    $scope.filter = {
        gender :'all'
    };

    $scope.userChat = {
        chat1: false,
        chat_user1:'',
        chat2: false,
        chat_user2:'',
        chat3: false,
        chat_user3:'',
        chat4: false,
        chat_user4:''
    };

    getCurrentUser();

    function locationUserPostRequest(url,data){

        appRequestApi.requestPost(location_url,data).then(function(res){
            console.log(res);

            shareData.setData(res);

            if(res.success==true){

                $scope.loc_search_user = res.location_search;

                if(res.location_search.length>0){

                    $scope.userChat.chat_user1 = $scope.loc_search_user[0];
                    console.log($scope.userChat.chat_user1);
                    $scope.userChat.chat1 = true;

                }
                if(res.location_search.length>1){
                    $scope.userChat.chat2 = true;
                    $scope.userChat.chat_user2 = $scope.loc_search_user[1];
                }
                if(res.location_search.length>2){
                    $scope.userChat.chat3 = true;
                    $scope.userChat.chat_user3 = $scope.loc_search_user[2];
                }
                if(res.location_search.length>3){
                    $scope.userChat.chat4 = true;
                    $scope.userChat.chat_user4 = $scope.loc_search_user[3];
                }


            }else{
                if(res.location_search==null){

                    console.log('location_search null');
                    var error_msg = 'No Result Found';

                    $cordovaToast
                        .show(error_msg, 'long', 'bottom')
                        .then(function(success) {
                            // success
                        }, function (error) {
                            // error
                        });

                    $scope.userChat = {
                        chat1: false,
                        chat_user1:'',
                        chat2: false,
                        chat_user2:'',
                        chat3: false,
                        chat_user3:'',
                        chat4: false,
                        chat_user4:''
                    };
                }
            }

        });
    }

    function getCurrentUser(){

        $scope.userChat = {
            chat1: false,
            chat_user1:'',
            chat2: false,
            chat_user2:'',
            chat3: false,
            chat_user3:'',
            chat4: false,
            chat_user4:''
        };

        var posOptions = {timeout: 10000, enableHighAccuracy: false};
        $cordovaGeolocation
            .getCurrentPosition(posOptions)
            .then(function (position) {
                var lat  = position.coords.latitude;
                var long = position.coords.longitude;

                var data = {
                    'lat' : lat,
                    'lng' : long
                };
                console.log('sddas');
                locationUserPostRequest(location_url,data);

            }, function(err) {
                // error
                console.log(err);
            });
    }

    function currentUserFilters(){

        var search_query_result = BASE_URL_API + 'user/search/location?gender='+$scope.filter.gender+'&range='+$scope.filter.range+'&signs='+$scope.filter.signs;
        var posOptions = {timeout: 10000, enableHighAccuracy: false};
        $cordovaGeolocation
            .getCurrentPosition(posOptions)
            .then(function (position) {
                var lat  = position.coords.latitude;
                var long = position.coords.longitude;

               /* var data = {
                    'lat' : lat,
                    'lng' : long,
                    'gender':$scope.filter.gender,
                    'range':$scope.filter.range,
                    'signs':$scope.filter.signs
                };*/
                var data = {
                    'lat': lat,
                    'lng': long,
                    'gender': $scope.filter.gender,
                    'range': $scope.filter.range,
                    'signs': $scope.filter.signs,
                    'min_age': $scope.slider.min,
                    'max_age': $scope.slider.max
                };

                locationUserPostRequest(search_query_result,data);

            }, function(err) {
                // error
                console.log(err);
            });


    }

    $scope.chooseAddress = function () {

        $timeout(function () {

            $scope.userChat = {
                chat1: false,
                chat_user1:'',
                chat2: false,
                chat_user2:'',
                chat3: false,
                chat_user3:'',
                chat4: false,
                chat_user4:''
            };

            customGeoReq.getLatLong($scope.field.address).then(function(val){

                var data = {
                    'lat' : val.lat,
                    'lng' : val.lng
                };
                
                console.log(data);

                locationUserPostRequest(location_url,data);

                
            });
        },200);

    };

    $scope.currentUserLocation = function () {

        $scope.field={address:''};

        $scope.userChat = {
            chat1: false,
            chat_user1:'',
            chat2: false,
            chat_user2:'',
            chat3: false,
            chat_user3:'',
            chat4: false,
            chat_user4:''
        };
        getCurrentUser();
    };

    $scope.filter = {};
    $scope.filter = {
        gender :'all',
        signs:'all'
    };

    $scope.getUserProfile = function(userId){
        $scope.user = {};
        $scope.user.user_id = 55;


        appRequestApi.requestPost(profile_url+'/other/profile',$scope.user).then(function(data){
            console.log(data);
        });

    }
    $ionicModal.fromTemplateUrl('app/templates/search-nearby/search-nearby-user-profile.html', {
        scope: $scope
    }).then(function(modal) {
        $scope.sortModal = modal;

    });
    $scope.openFilter = function(){

        /*$ionicLoading.show({
            template: '<ion-spinner ></ion-spinner>'
        });*/

        var search_query_result = BASE_URL_API + 'user/search/location?gender='+$scope.filter.gender+'&range='+$scope.filter.range+'&signs='+$scope.filter.signs;

        $timeout(function () {
            if($scope.field.address==''){
                currentUserFilters();
            }else {
                $scope.userChat = {
                    chat1: false,
                    chat_user1: '',
                    chat2: false,
                    chat_user2: '',
                    chat3: false,
                    chat_user3: '',
                    chat4: false,
                    chat_user4: ''
                };

                customGeoReq.getLatLong($scope.field.address).then(function (val) {

                    var data = {
                        'lat': val.lat,
                        'lng': val.lng,
                        'gender': $scope.filter.gender,
                        'range': $scope.filter.range,
                        'signs': $scope.filter.signs,
                        'min_age': $scope.slider.min,
                        'max_age': $scope.slider.max
                    };

                    locationUserPostRequest(search_query_result, data);

                });
            }
        },200);
    };

    $scope.selectGender = function (value,event) {
        // console.log(value,$(event.target).closest("div").addClass('icon-bg'));
        switch (value){
            case 'all':
                $scope.filter.gender = 'all';
                break;
            case 'male':
                $scope.filter.gender = 'male';
                break;
            case 'female':
                $scope.filter.gender = 'female';
                break;
            default :
                $scope.filter.gender = 'all';
        }
    };

    $scope.$parent.socket_check();

    appRequestApi.requestGet(profile_url).then(function(data){

        $scope.user = data.data;
        
    });

    $scope.connectUser = function (id) {
        alert(id);
    };

    $scope.disableTap = function () {
        var container = document.getElementsByClassName('pac-container');// disable ionic data tab
        angular.element(container).attr('data-tap-disabled', 'true');
        // leave input field if google-address-entry is selected
        angular.element(container).on("click", function () {
            document.getElementById('location_google').blur();
        });
    };

}]).directive('myEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if(event.which === 13) {
                scope.$apply(function (){
                    scope.$eval(attrs.myEnter);
                });

                event.preventDefault();
            }
        });
    };
});