/**
 * Created by osp57 on 28/11/16.
 */

'use strict';
var app = angular.module('zodiac');

app.controller('SignupController', ['$scope', '$state', '$cordovaCamera','appRequestApi','BASE_URL_API','$cordovaDatePicker','$ionicLoading','$ionicPopup','$ionicActionSheet','$timeout','$ionicModal', function ($scope, $state, $cordovaCamera,appRequestApi,BASE_URL_API,$cordovaDatePicker,$ionicLoading,$ionicPopup,$ionicActionSheet,$timeout,$ionicModal) {
            


    $scope.modal = false;
    // First function to register user and go to next page
    $scope.signup = function (register) {

        if(register.username.$invalid!=true){

            $('#sign-up-1').css('display', 'none');
            $('#sign-up-2').css('display', 'block');
            $('.signup-back').css('display', 'block');
            $('#back-btn-1').css('display', 'none');

        }

    };


    $scope.change ={
        location : false
    };

    $scope.locationChange = function () {
        $scope.change ={
            location : true
        };
        console.log($scope.change.location);
    };

    $scope.user = {};

    $scope.valid = {
        email:true
    };

    
    $scope.changeLocation = function(){
        $scope.change_location = false;
    };

    // Final function to register user return true and false
    $scope.register_user = function (next_register) {
        // cordova.plugins.Keyboard.close();
                 var register_user = BASE_URL_API + 'register';
        // $scope.user.location = $scope.user.location.formatted_address;

        if(next_register.email.$invalid !=true){

            // var location = ;

            // $scope.user.location = $scope.user.location.formatted_address;
            //use register api to register user

            $ionicLoading.show({
                template: '<ion-spinner ></ion-spinner>'
            });
            
            appRequestApi.requestPost(register_user,$scope.user).then(function(data){

                $ionicLoading.hide();

                if(data.status==true){

                    $state.go('welcome');

                }else{
                    
                    var msg ;
                    if(data.message==undefined){
                        msg ='Please try again!';
                    }else{
                        msg =data.message;
                    }

                  
                    var myPopup = $ionicPopup.show({
                        template: '<p>'+msg+'</p>',
                        title: 'Please try again!',
                        scope: $scope,
                        buttons: [
                            { text: '<img src="img/pop-up-cross.png">' },
                            {
                                text: 'Done',
                                type: 'button-positive',
                                onTap: function(e) {
                                    return true;
                                }
                            },
                        ]
                    });

                    };

            });

        }
            };


    $scope.checkUsername = function(username){

        var newValue = $scope.user.username;

        if(newValue){

            if(newValue.length>3) {

                var check_username_url = BASE_URL_API+'check/username?username='+newValue;

                console.log(newValue);

                appRequestApi.requestGet(check_username_url).then(function(data){

                    // return true if username is available
                    if(data.success==true){

                        username.$invalid=false;

                    }else{
                        // false if username is unavailable

                        username.$invalid=true;

                    }

                });

            }
        }
    };

    $scope.calculateAge = function(birthday) { // pass in player.dateOfBirth
        var ageDifMs = Date.now() - new Date(birthday);
        var ageDate = new Date(ageDifMs); // miliseconds from epoch
        return Math.abs(ageDate.getUTCFullYear() - 1970);
    }

    $scope.checkEmail = function(email){

        var newValue = $scope.user.email;

        if(newValue){

            if(newValue.length>3) {

                var check_email_url = BASE_URL_API+'check/email?email='+newValue;

                console.log(newValue);

                appRequestApi.requestGet(check_email_url).then(function(data){

                    // return true if username is available
                    if(data.success==true){

                        email.$invalid=false;
                        email.$setValidity('emailmatch', true);
                        $scope.valid.email = true;

                    }else{
                        // false if username is unavailable

                        email.$invalid=true;
                        email.$setValidity('emailmatch', false);
                        $scope.valid.email = false;

                    }

                });

            }
        }
    };

    $scope.signUpBack = function () {

        $('#sign-up-1').css('display','block');
        $('#sign-up-2').css('display','none');
        $('.signup-back').css('display','none');
        $('#back-btn-1').css('display','block');

    };

    var options = {

        mode: 'date',
        maxDate: new Date() - 10000,
        allowOldDates: true,
        allowFutureDates: false,
        doneButtonLabel: 'DONE',
        doneButtonColor: '#000000',
        cancelButtonLabel: 'CANCEL',
        cancelButtonColor: '#000000'
    };

    // Get birthday using cordovaDatePicker plugin
    $scope.getBirthDate = function () {

        options.date = new Date();

        if ($scope.user.birth_date != undefined) {
            var temp_date = new Date($scope.user.birth_date);
            options.date = new Date(temp_date.getFullYear(), temp_date.getMonth(), temp_date.getDate());

        }

        //uncomment when build
        $cordovaDatePicker.show(options).then(function(date){

            $scope.user.birth_date = convertDate(date);
            if($scope.user.birth_date){
               $scope.ageLimit =   $scope.calculateAge($scope.user.birth_date);

            }
        });
    };

    function convertDate(date) {

        var yyyy = date.getFullYear().toString();
        var mm = (date.getMonth()+1).toString();
        var dd  = date.getDate().toString();

        var mmChars = mm.split('');
        var ddChars = dd.split('');

        return yyyy + '-' + (mmChars[1]?mm:"0"+mmChars[0]) + '-' + (ddChars[1]?dd:"0"+ddChars[0]);
    }

    $scope.cameraOpen = function () {

        var showActionSheet = $ionicActionSheet.show({
            buttons: [
                { text: '<i class="icon bg ion-camera"></i> Camera' },
                { text: '<i class="icon bg ion-ios-folder"></i> Gallery' }
            ],

            titleText: 'Choose Image',
            cancelText: 'Cancel',

            cancel: function () {
                // add cancel code...
            },

            buttonClicked: function (index) {
                if (index === 0) {
                    // add edit 1 code
                    capture_image(1,showActionSheet);

                }

                if (index === 1) {
                    // add edit 2 code
                    capture_image(0,showActionSheet);

                }
            }
        });


    };

    function capture_image(st,showActionSheet) {
        $timeout(function() {
            showActionSheet();
        }, 2000);

        var options = {
            quality: 50,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: st,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 100,
            targetHeight: 100,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: true,
            correctOrientation:true
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {

            $('#profile_pic').css('display', 'block');
            var image = document.getElementById('profile_pic');
            $('.img-icon span').css('padding', '0');
            $('#icon-cam').remove();
            image.src = "data:image/jpeg;base64," + imageData;
            $scope.user.image = image.src;

        }, function (err) {
            console.log(err);
        });
    }
    
    $scope.chooseNewUserAddress = function () {

        $timeout(function() {
            $scope.user.location = document.getElementById('location_google').value;
            
        }, 100);

    }

    $scope.disableTap = function () {
        var container = document.getElementsByClassName('pac-container');// disable ionic data tab
        angular.element(container).attr('data-tap-disabled', 'true');
        // leave input field if google-address-entry is selected
        angular.element(container).on("click", function () {
            document.getElementById('location_google').blur();
        });
    };

}]).directive('pwCheck', [function () {
    return {
        require: 'ngModel',
        link: function (scope, elem, attrs, ctrl) {

            var firstPassword = '#' + attrs.pwCheck;
            elem.on('keyup', function () {
                console.log(attrs.pwCheck);
                console.log(firstPassword);
                scope.$apply(function () {
                    var v = elem.val()===$(firstPassword).val();
                    console.log(v);
                    ctrl.$setValidity('pwmatch', v);
                });
            });
        }
    }
}]);
